package validator;

import javax.servlet.http.*;


import java.io.*;

import javax.servlet.*;

public class Controller extends HttpServlet {

	private static final long serialVersionUID = 1L;
	private ServletContext servletContext;

	public Controller() {
		super();
	}

	public void destroy() {
		System.out.println("Servlet: destroy");
	}
	
	public void init(ServletConfig config) throws ServletException {

		System.out.println("Servlet: init");
		servletContext = config.getServletContext();

		System.out.println("Servlet initialized");
	}
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		//Redirijo a la vista inicial
		RequestDispatcher rd = servletContext.getRequestDispatcher(res.encodeURL("/index.jsp"));
		rd.forward(req, res);
	}


	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		//Recibimos el código introducido por el usuario
		String code = req.getParameter("code");
		String errors = "";
		String correctedCode = "";
		//Pasamos el código al parser y obtenemos los resultados
		try {
			String out[] = parser.main(code);
			errors = out[1];
			correctedCode = out[0];
		} catch(Exception e) {
			//Si ocurre un error, informo convenientemente en la vista
			errors = "Ha ocurrido un error (" +  e.getMessage() + ") y la ejecución se ha detenido.";
			correctedCode = "";
			
		}
		//Pasamos los resultados del validador a la vista
		req.setAttribute("errors", errors);
		req.setAttribute("code", code);
		req.setAttribute("correctedCode", correctedCode);
		
		RequestDispatcher rd = servletContext.getRequestDispatcher(res.encodeURL("/index.jsp"));
		rd.forward(req, res);
	}
}